package com.uniyaz.test;

import java.io.IOException;
import java.util.Map;

import javax.servlet.ServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

import com.vaadin.server.RequestHandler;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinResponse;
import com.vaadin.server.VaadinSession;

public class MyCustomRequestHandler implements RequestHandler {

    @Override
    public boolean handleRequest(VaadinSession session, VaadinRequest request, VaadinResponse response) throws IOException {
       //The method is called twice for every request??
    	
    	System.err.println("handleRequest is called.");
    	
    	System.out.println("VaadinRequest:" + request.getParameter("field1"));
    	writeParameters(request.getParameterMap());
    	
    	HttpServletRequestWrapper requestWrapper = (HttpServletRequestWrapper)request;
    	System.out.println("HttpServletRequestWrapper" + requestWrapper.getParameter("field1"));
    	writeParameters(requestWrapper.getParameterMap());
    	
    	ServletRequest servletRequest = requestWrapper.getRequest();
    	System.out.println("ServletRequest" + servletRequest.getParameter("field1"));
    	writeParameters(servletRequest.getParameterMap());
    	
    	
        return false;
    }

	private void writeParameters(Map<String, String[]> parameterMap) {
		for (String key : parameterMap.keySet()) {
			System.out.println(key + ":" + parameterMap.get(key));
		}
		
	}
	
}
